clear all;
close all;

global left_feeder right_feeder nb_right_trial nb_wrong_trial reward_duration_li reward_duration_re masker_atn;
global het_freq recdur std_atn_db irpts f double_blind pcorrh record_on side_seq actxh;
global result filename  messages feedbbuf feedback_min_dur masker_atn_def masker_atn_0 fs;
global playchan call frep;
double_blind=1;
nb_right_reward=0;
nb_left_reward=0;
left_feeder=2;
right_feeder=1;
reward_duration_li=0.4;
reward_duration_re=0.5;
het_freq=45000;         % heterodyning frequency for audio monitoring
record_on=0;

fs=192000;
het_loud=3;
rec_dur=4; % length of audio ringbuffer for trial documentation
nbufs=2;
feedback_threshold_output=-6;
feedback_min_dur=0.1;
masker_atn_def=-39; %masker attenuation [dB] in conditions with maskers present
masker_atn_0=-200; %masker attenuation [dB] in condition without maskers
masker_atn=masker_atn_0;


output_channels=0:5;
playchan=0:length(output_channels)-1;

rand('state',sum(100*clock));
messages={'';'';'';'';'';'';'';'';'';'';''};

load('100000_random_sides.mat'); % loads variable "side_seq" with a random sequence of 100,000 signal-sides
% make sure feeders are off
ppset_conny('lpt3',0);

%prepare soundmex
if 1 ~= soundmexpro('init','driver','ASIO Fireface','samplerate',fs,'output',output_channels,'track',6,'numbufs',nbufs);
    error(['error calling ''init''' error_loc(dbstack)]);
end


%soundmexpro('show');

% get asio properties
[ret,fs_ff800,bufsiz]=soundmexpro('getproperties');
fs=fs_ff800;
feedbbuf=round(feedback_min_dur*fs_ff800/bufsiz);
%set clipthreshold
if 1 ~= soundmexpro('clipthreshold','type','output','value',10^(feedback_threshold_output/20));
    error('error setting clipthreshold');
end


%Synthetic call
f1=23e3; %frequency sweep from 23 to 19 kHz
f2=19e3;
T=1.5e-3; %duration of call: 1.5 ms
dt=1/fs;
t=0:dt:T-dt; 
dB=[-30 -10 -5 0]; %attenuation of the 4 harmonics
amp=10.^(dB./20);
frep=2;     % repetition frequency for call presentation
call_atn=-24;
%generate samples of linear swept-frequency: y=chirp(t,f0,T1,f1)
call=zeros(1,length(t));
for i=1:length(amp)
    call=call+amp(i).*chirp(t,f1*i,T,f2*i); 
end
call=wind(fs,0.2e-3,call); 
call=call';
call=call*(10^(call_atn/20));
% call=[call;zeros(round(fs/frep-length(call)),1)];


global fh start left_handle right_handle abort_handle start_handle...
    end_session side nb_trial nb_aborted_trial left_feeder_handle right_feeder_handle rovh...
    nb_manual_reward name_handle message_handle atnh masker_handle nth recordh maskeratns_handle sigdelh...
    right_feeder_auto_handle left_feeder_auto_handle
ppset_conny('lpt3',0);
fh=resp1gui;
set(fh,'Position',[ 20.2000   41.1538  133.8000   35.3846]);
ppset_conny('lpt3',0);
left_handle=findobj(fh,'tag','left');
right_handle=findobj(fh,'tag','right');
abort_handle=findobj(fh,'tag','abort');
start_handle=findobj(fh,'tag','start');
left_feeder_handle=findobj(fh,'tag','reward_left');
right_feeder_handle=findobj(fh,'tag','reward_right');
name_handle=findobj(fh,'tag','names');
masker_handle=findobj(fh,'tag','maskers');
message_handle=findobj(fh,'tag','message');
atnh=findobj(fh,'tag','atn');
nth=findobj(fh,'tag','nt');
pcorrh=findobj(fh,'tag','pcorr');
recordh=findobj(fh,'tag','record_on');
maskeratns_handle=findobj(fh,'tag','masker_atns');
sigdelh=findobj(fh,'tag','sigdel');
rovh=findobj(fh,'tag','rov_lvl');
left_feeder_auto_handle=findobj(fh,'tag','reward_left_auto');
right_feeder_auto_handle=findobj(fh,'tag','reward_right_auto');

set(start_handle,'string','Start','backgroundcolor',[0 0.498 0],'enable','on');
set(abort_handle,'backgroundcolor',[0.847 0.161 0],'enable','off');
set([left_handle right_handle],'backgroundcolor',[0.749 0.749 0],'enable','on');


